package com.gic.store.service;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.store.dto.StoreStrategyDTO;

/**
 * @author guojx
 * @date 2019/7/4 9:44 AM
 */
public interface StoreStrategyApiService {

    /**
     * 新增 分组策略数据
     * @param storeStrategyDTO
     * @return
     */
    ServiceResponse<Integer> saveStoreGroupStrategy(StoreStrategyDTO storeStrategyDTO);


    /**
     * 删除分组策略（单条）
     * @param strategyId
     * @return
     */
    ServiceResponse<Integer> deleteStoreGroupStrategy(int strategyId);

    /**
     * 修改分组策略
     * @param storeStrategyDTO
     * @return
     */
    ServiceResponse<Integer> modifyStoreGroupStrategy(StoreStrategyDTO storeStrategyDTO);


    /**
     * 根据主键ID获取数据
     * @param strategyId
     * @return
     */
    ServiceResponse<StoreStrategyDTO> getStoreGroupStrategyById(int strategyId);

    /**
     * 置底
     * @param strategyId
     * @return
     */
    ServiceResponse<Integer> sortBottom(int strategyId);

    /**
     * 置顶
     * @param strategyId
     * @return
     */
    ServiceResponse<Integer> sortTopping(int strategyId);

    /**
     * 上移、下移
     * @param strategyId
     * @param isUp
     * @return
     */
    ServiceResponse<Integer> upOrDown(int strategyId, boolean isUp);

    /**
     * 设置排序值
     * @param strategyId
     * @param setValue
     * @return
     */
    ServiceResponse<Integer> setStoreStrategySort(int strategyId, int setValue);

    /**
     * 分页查询分组策略数据
     * @param enterpriseId
     * @param search
     * @param strategyType
     * @param pageNum
     * @param pageSize
     * @return
     */
    ServiceResponse<Page<StoreStrategyDTO>> listStoreField(int enterpriseId, String search, int strategyType, Integer pageNum, Integer pageSize);

    /**
     * 获取权重设置
     * @param enterpriseId
     * @return
     */
    ServiceResponse<Integer> getWeightsByEnterpriseId(int enterpriseId);

    /**
     * 更改权重设置
     * @param status
     * @param enterpriseId
     * @return
     */
    ServiceResponse<Integer> saveOrUpdateWeights(int status, int enterpriseId);
}
