package com.gic.store.service.impl;

import com.gic.store.dao.mapper.TabStoreGroupStrategyWeightsMapper;
import com.gic.store.entity.TabStoreGroupStrategyWeights;
import com.gic.store.service.StoreGroupStrategyWeightsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

/**
 * @author guojx
 * @date 2019/7/4 9:26 AM
 */
@Service("storeGroupStrategyWeightsService")
public class StoreGroupStrategyWeightsServiceImpl implements StoreGroupStrategyWeightsService{

    @Autowired
    private TabStoreGroupStrategyWeightsMapper tabStoreGroupStrategyWeightsMapper;

    @Override
    public TabStoreGroupStrategyWeights getWeightByEnterpriseId(Integer enterpriseId) {
        TabStoreGroupStrategyWeights record = new TabStoreGroupStrategyWeights();
        record.setEnterpriseId(enterpriseId);
        return tabStoreGroupStrategyWeightsMapper.selectByPrimary(record);
    }

    @Override
    public int saveOrUpdate(TabStoreGroupStrategyWeights record) {
        TabStoreGroupStrategyWeights old = getWeightByEnterpriseId(record.getEnterpriseId());
        record.setUpdateTime(new Date());
        if (old != null) {
            record.setCreateTime(old.getCreateTime());
            record.setWeightsId(old.getWeightsId());
            return tabStoreGroupStrategyWeightsMapper.updateByPrimaryKeySelective(record);
        } else {
            record.setCreateTime(new Date());
            return tabStoreGroupStrategyWeightsMapper.insert(record);
        }
    }

    @Override
    public boolean isEnabled(Integer enterpriseId) {
        TabStoreGroupStrategyWeights old = getWeightByEnterpriseId(enterpriseId);
        if (old != null && old.getStatus() != null && old.getStatus().intValue() == 1) {
            return true;
        }
        return false;
    }
}
